package cn.com.infosec.mobile.android;

import android.content.Context;
import android.support.annotation.NonNull;
import android.text.TextUtils;
import android.util.Base64;
import android.util.SparseArray;
import cn.com.infosec.mobile.android.algorithm.SM2;
import cn.com.infosec.mobile.android.otp.InfosecOTP;
import cn.com.infosec.mobile.android.result.Result;
import cn.com.infosec.mobile.android.util.Util;
import cn.com.infosec.mobile.android.xlog.XLog;
import java.io.IOException;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

public class IMSTokenAction extends IMSAction {
   private InfosecOTP infosecOTP;

   public IMSTokenAction(Context context) {
      IMSTokenAction var10000 = this;
      super(context);
      InfosecOTP var2;
      var2 = new InfosecOTP.<init>();
      var10000.infosecOTP = var2;
   }

   private void writeSeedWithID(@NonNull String userName, @NonNull String PIN, String seed, String seedID) {
      IOException var10000;
      label120: {
         boolean var10001;
         boolean var25;
         try {
            var25 = TextUtils.isEmpty(seed);
         } catch (IOException var20) {
            var10000 = var20;
            var10001 = false;
            break label120;
         }

         if (var25) {
            return;
         }

         try {
            var25 = TextUtils.isEmpty(seedID);
         } catch (IOException var19) {
            var10000 = var19;
            var10001 = false;
            break label120;
         }

         if (var25) {
            return;
         }

         IMSTokenAction var10002;
         byte[] var10003;
         IMSTokenAction var26;
         String var27;
         try {
            var26 = this;
            var27 = userName;
            var10002 = this;
            var10003 = (byte[])this.readCacheData("OTP_SEED_PROTECT_KEY");
         } catch (IOException var18) {
            var10000 = var18;
            var10001 = false;
            break label120;
         }

         byte[] var5 = var10003;

         SM2 var28;
         try {
            var28 = new SM2;
         } catch (IOException var17) {
            var10000 = var17;
            var10001 = false;
            break label120;
         }

         SM2 var6 = var28;

         IMSTokenAction var10004;
         byte[] var10005;
         try {
            var10004 = this;
            var6.<init>();
            var10005 = var6.decryptWithoutASN(Base64.decode(seed, 2), var5);
         } catch (IOException var16) {
            var10000 = var16;
            var10001 = false;
            break label120;
         }

         byte[] seed1 = var10005;

         String var29;
         try {
            var29 = var28.encode(Base64.decode(var10004.infosecOTP.getPubKey(userName.concat("_").concat(seedID)), 2), seed1, false);
         } catch (IOException var15) {
            var10000 = var15;
            var10001 = false;
            break label120;
         }

         seed = var29;

         try {
            var10002.infosecOTP.writeSeed(userName.concat("_").concat(seedID), seed, PIN);
         } catch (IOException var14) {
            var10000 = var14;
            var10001 = false;
            break label120;
         }

         Set var30;
         try {
            var30 = var26.getUserSP(var27).getStringSet("SEED_IDS", (Set)null);
         } catch (IOException var13) {
            var10000 = var13;
            var10001 = false;
            break label120;
         }

         Set PIN1 = var30;

         HashSet var31;
         try {
            var31 = new HashSet;
         } catch (IOException var12) {
            var10000 = var12;
            var10001 = false;
            break label120;
         }

         HashSet seed2 = var31;

         try {
            var31.<init>();
         } catch (IOException var11) {
            var10000 = var11;
            var10001 = false;
            break label120;
         }

         if (var30 != null) {
            int var32;
            try {
               var32 = PIN1.size();
            } catch (IOException var10) {
               var10000 = var10;
               var10001 = false;
               break label120;
            }

            if (var32 > 0) {
               try {
                  seed2.addAll(PIN1);
               } catch (IOException var9) {
                  var10000 = var9;
                  var10001 = false;
                  break label120;
               }
            }
         }

         try {
            var26 = this;
            var27 = userName;
            seed2.add(seedID);
         } catch (IOException var8) {
            var10000 = var8;
            var10001 = false;
            break label120;
         }

         try {
            var26.getUserSP(var27).edit().putStringSet("SEED_IDS", seed2).apply();
            XLog.d("writeSeedWithID 成功");
            return;
         } catch (IOException var7) {
            var10000 = var7;
            var10001 = false;
         }
      }

      IOException var21 = var10000;
      IMSSdk.mLogger.log(Level.SEVERE, "申请种子失败:JSON异常", var21);
      XLog.d("writeSeedWithID 失败:JSON异常" + var21);
   }

   public Map<String, String> seedBegin(@NonNull String userName, @NonNull String PIN) {
      if (!TextUtils.isEmpty(userName) && !TextUtils.isEmpty(PIN)) {
         if (PIN.length() >= 256) {
            XLog.d("申请种子失败:PIN过长" + Arrays.toString(new String[]{PIN}));
            this.setLatestResult(new Result("IE1013"));
            return null;
         } else {
            HashMap var4 = new HashMap();
            var4.put("username", userName);
            SparseArray var10003 = (new SM2()).genKeyPair(userName);
            this.writeCacheData("OTP_SEED_PROTECT_KEY", var10003.get(0));
            var4.put("sm2pubkey", Base64.encodeToString((byte[])var10003.get(1), 2));
            var4.put("imei", Util.getIdentifier(IMSSdk.mContext));
            return var4;
         }
      } else {
         IMSTokenAction var10000 = this;
         Logger var10001 = IMSSdk.mLogger;
         Level var10002 = Level.SEVERE;
         String[] var3;
         (var3 = new String[1])[0] = userName;
         var10001.log(var10002, "申请种子失败:参数不合法", var3);
         XLog.d("申请种子失败:参数不合法" + Arrays.toString(new String[]{userName}));
         var10000.setLatestResult(new Result("IE1013"));
         return null;
      }
   }

   public Result seedFinal(@NonNull String userName, @NonNull String PIN, JSONObject responseData) {
      Object var43;
      label180: {
         JSONException var47;
         label179: {
            IOException var10000;
            label182: {
               boolean var10001;
               Result var48;
               try {
                  var48 = this.checkResponseData(responseData);
               } catch (JSONException var39) {
                  var47 = var39;
                  var10001 = false;
                  break label179;
               } catch (IOException var40) {
                  var10000 = var40;
                  var10001 = false;
                  break label182;
               }

               Result var4 = var48;
               String var49 = "000000";

               boolean var50;
               try {
                  var50 = TextUtils.equals(var49, var4.getResultID());
               } catch (JSONException var37) {
                  var47 = var37;
                  var10001 = false;
                  break label179;
               } catch (IOException var38) {
                  var10000 = var38;
                  var10001 = false;
                  break label182;
               }

               if (!var50) {
                  try {
                     XLog.d("下载种子失败： " + var4.getResultID());
                     return var4;
                  } catch (JSONException var7) {
                     var47 = var7;
                     var10001 = false;
                     break label179;
                  } catch (IOException var8) {
                     var10000 = var8;
                     var10001 = false;
                  }
               } else {
                  label183: {
                     String var10002;
                     String var10003;
                     JSONObject var10004;
                     String var10005;
                     JSONObject var53;
                     IMSTokenAction var54;
                     try {
                        var53 = responseData;
                        var54 = this;
                        var10002 = userName;
                        var10003 = PIN;
                        var10004 = responseData;
                        var10005 = responseData.getString("seed");
                     } catch (JSONException var35) {
                        var47 = var35;
                        var10001 = false;
                        break label179;
                     } catch (IOException var36) {
                        var10000 = var36;
                        var10001 = false;
                        break label183;
                     }

                     String var44 = var10005;

                     JSONArray var57;
                     try {
                        var54.writeSeedWithID(var10002, var10003, var44, var10004.optString("seedId"));
                        var57 = var53.optJSONArray("pcseeds");
                     } catch (JSONException var33) {
                        var47 = var33;
                        var10001 = false;
                        break label179;
                     } catch (IOException var34) {
                        var10000 = var34;
                        var10001 = false;
                        break label183;
                     }

                     JSONArray var5 = var57;
                     String var60;
                     IMSTokenAction var61;
                     if (var57 != null) {
                        int var58;
                        try {
                           var58 = var5.length();
                        } catch (JSONException var31) {
                           var47 = var31;
                           var10001 = false;
                           break label179;
                        } catch (IOException var32) {
                           var10000 = var32;
                           var10001 = false;
                           break label183;
                        }

                        if (var58 > 0) {
                           int var6 = 0;

                           while(true) {
                              int var59;
                              try {
                                 var58 = var6;
                                 var59 = var5.length();
                              } catch (JSONException var25) {
                                 var47 = var25;
                                 var10001 = false;
                                 break label179;
                              } catch (IOException var26) {
                                 var10000 = var26;
                                 var10001 = false;
                                 break label183;
                              }

                              if (var58 >= var59) {
                                 break;
                              }

                              JSONObject var52;
                              String var56;
                              try {
                                 var61 = this;
                                 var60 = userName;
                                 var10002 = PIN;
                                 var52 = var5.getJSONObject(var6);
                                 var56 = var52.optString("seed");
                              } catch (JSONException var29) {
                                 var47 = var29;
                                 var10001 = false;
                                 break label179;
                              } catch (IOException var30) {
                                 var10000 = var30;
                                 var10001 = false;
                                 break label183;
                              }

                              var44 = var56;

                              try {
                                 var61.writeSeedWithID(var60, var10002, var44, var52.optString("seedId"));
                              } catch (JSONException var27) {
                                 var47 = var27;
                                 var10001 = false;
                                 break label179;
                              } catch (IOException var28) {
                                 var10000 = var28;
                                 var10001 = false;
                                 break label183;
                              }

                              ++var6;
                           }
                        }
                     }

                     byte[] var62;
                     try {
                        var61 = this;
                        var62 = (byte[])this.readCacheData("OTP_SEED_PROTECT_KEY");
                     } catch (JSONException var23) {
                        var47 = var23;
                        var10001 = false;
                        break label179;
                     } catch (IOException var24) {
                        var10000 = var24;
                        var10001 = false;
                        break label183;
                     }

                     byte[] var45 = var62;

                     SM2 var63;
                     try {
                        var63 = new SM2;
                     } catch (JSONException var21) {
                        var47 = var21;
                        var10001 = false;
                        break label179;
                     } catch (IOException var22) {
                        var10000 = var22;
                        var10001 = false;
                        break label183;
                     }

                     SM2 var46 = var63;

                     IMSTokenAction var51;
                     byte[] var55;
                     try {
                        var51 = this;
                        var46.<init>();
                        var55 = var46.decryptWithoutASN(Base64.decode(var44, 2), var45);
                     } catch (JSONException var19) {
                        var47 = var19;
                        var10001 = false;
                        break label179;
                     } catch (IOException var20) {
                        var10000 = var20;
                        var10001 = false;
                        break label183;
                     }

                     byte[] var41 = var55;

                     try {
                        var60 = var63.encode(Base64.decode(var51.infosecOTP.getPubKey(userName), 2), var41, false);
                     } catch (JSONException var17) {
                        var47 = var17;
                        var10001 = false;
                        break label179;
                     } catch (IOException var18) {
                        var10000 = var18;
                        var10001 = false;
                        break label183;
                     }

                     String var42 = var60;

                     Result var64;
                     try {
                        XLog.d("申请种子成功");
                        var64 = new Result;
                     } catch (JSONException var15) {
                        var47 = var15;
                        var10001 = false;
                        break label179;
                     } catch (IOException var16) {
                        var10000 = var16;
                        var10001 = false;
                        break label183;
                     }

                     var4 = var64;

                     try {
                        var50 = var61.infosecOTP.writeSeed(userName, var42, PIN);
                     } catch (JSONException var13) {
                        var47 = var13;
                        var10001 = false;
                        break label179;
                     } catch (IOException var14) {
                        var10000 = var14;
                        var10001 = false;
                        break label183;
                     }

                     if (var50) {
                        try {
                           var49 = responseData.getString("resultcode");
                        } catch (JSONException var11) {
                           var47 = var11;
                           var10001 = false;
                           break label179;
                        } catch (IOException var12) {
                           var10000 = var12;
                           var10001 = false;
                           break label183;
                        }

                        var42 = var49;
                     } else {
                        var42 = "IE1004";
                     }

                     try {
                        var4.<init>(var42);
                        return var4;
                     } catch (JSONException var9) {
                        var47 = var9;
                        var10001 = false;
                        break label179;
                     } catch (IOException var10) {
                        var10000 = var10;
                        var10001 = false;
                     }
                  }
               }
            }

            var43 = var10000;
            break label180;
         }

         var43 = var47;
      }

      IMSSdk.mLogger.log(Level.SEVERE, "申请种子失败:JSON异常", (Throwable)var43);
      XLog.d("申请种子失败:JSON异常：" + var43);
      return new Result("IE1008", responseData.toString());
   }

   public Map<String, String> statusOnLineBegin(@NonNull String userName) {
      if (TextUtils.isEmpty(userName)) {
         IMSTokenAction var2 = this;
         Logger var10001 = IMSSdk.mLogger;
         Level var10002 = Level.SEVERE;
         String[] var3;
         (var3 = new String[1])[0] = userName;
         var10001.log(var10002, "获取状态失败:参数不合法", var3);
         XLog.d("获取状态失败:参数不合法" + Arrays.toString(new String[]{userName}));
         var2.setLatestResult(new Result("IE1013"));
         return null;
      } else {
         HashMap var10000 = new HashMap();
         var10000.put("username", userName);
         var10000.put("imei", Util.getIdentifier(IMSSdk.mContext));
         return var10000;
      }
   }

   public Result statusOnLineFinal(JSONObject responseData) {
      JSONException var10000;
      label84: {
         Result var16;
         boolean var10001;
         try {
            var16 = this.checkResponseData(responseData);
         } catch (JSONException var13) {
            var10000 = var13;
            var10001 = false;
            break label84;
         }

         Result var14 = var16;
         String var17 = "000000";

         boolean var18;
         try {
            var18 = TextUtils.equals(var17, var14.getResultID());
         } catch (JSONException var12) {
            var10000 = var12;
            var10001 = false;
            break label84;
         }

         if (!var18) {
            return var14;
         }

         int var19;
         try {
            var19 = responseData.getInt("netpassstate");
         } catch (JSONException var11) {
            var10000 = var11;
            var10001 = false;
            break label84;
         }

         switch (var19) {
            case 0:
               try {
                  var16 = new Result;
               } catch (JSONException var4) {
                  var10000 = var4;
                  var10001 = false;
                  break label84;
               }

               var14 = var16;

               try {
                  var16.<init>("IE1022");
                  break;
               } catch (JSONException var3) {
                  var10000 = var3;
                  var10001 = false;
                  break label84;
               }
            case 1:
               try {
                  var16 = new Result;
               } catch (JSONException var6) {
                  var10000 = var6;
                  var10001 = false;
                  break label84;
               }

               var14 = var16;

               try {
                  var16.<init>("IE1024");
                  break;
               } catch (JSONException var5) {
                  var10000 = var5;
                  var10001 = false;
                  break label84;
               }
            case 2:
               try {
                  var16 = new Result;
               } catch (JSONException var8) {
                  var10000 = var8;
                  var10001 = false;
                  break label84;
               }

               var14 = var16;

               try {
                  var16.<init>("IE1023");
                  break;
               } catch (JSONException var7) {
                  var10000 = var7;
                  var10001 = false;
                  break label84;
               }
            case 3:
               try {
                  var16 = new Result;
               } catch (JSONException var10) {
                  var10000 = var10;
                  var10001 = false;
                  break label84;
               }

               var14 = var16;

               try {
                  var16.<init>("IE1025");
               } catch (JSONException var9) {
                  var10000 = var9;
                  var10001 = false;
                  break label84;
               }
         }

         try {
            XLog.d("获取状态成功：" + var14.getResultID());
            return var14;
         } catch (JSONException var2) {
            var10000 = var2;
            var10001 = false;
         }
      }

      JSONException var15 = var10000;
      IMSSdk.mLogger.log(Level.SEVERE, "获取状态失败:JSON异常", var15);
      XLog.d("获取状态失败:JSON异常" + var15);
      return new Result("IE1008", responseData.toString());
   }

   public String getOTP(@NonNull String userName, @NonNull String PIN, @NonNull String algorithm, long time, String challenge, int digit, int step) {
      if (IMSSdk.enableDebugLog) {
         StringBuilder var10000 = (new StringBuilder()).append("getOTP");
         String[] var9;
         String[] var10001 = var9 = new String[7];
         var9[0] = userName;
         var9[1] = PIN;
         var9[2] = algorithm;
         var9[3] = String.valueOf(time);
         var9[4] = challenge;
         var9[5] = String.valueOf(digit);
         var10001[6] = String.valueOf(step);
         XLog.d(var10000.append(Arrays.toString(var10001)).toString());
      }

      String var10 = this.infosecOTP.getOTPNative(userName, PIN, algorithm, time, challenge, digit, step);
      if (IMSSdk.enableDebugLog) {
         XLog.d("getOTP " + var10);
      }

      return var10;
   }

   public String getOTPWithID(@NonNull String userName, @NonNull String seedID, @NonNull String PIN, @NonNull String algorithm, long time, String challenge, int digit, int step) {
      if (IMSSdk.enableDebugLog) {
         StringBuilder var10000 = (new StringBuilder()).append("getOTPWithID");
         String[] var10;
         String[] var10001 = var10 = new String[8];
         var10[0] = userName;
         var10[1] = seedID;
         var10[2] = PIN;
         var10[3] = algorithm;
         var10[4] = String.valueOf(time);
         var10[5] = challenge;
         var10[6] = String.valueOf(digit);
         var10001[7] = String.valueOf(step);
         XLog.d(var10000.append(Arrays.toString(var10001)).toString());
      }

      String var11 = this.infosecOTP.getOTPNative(userName.concat("_").concat(seedID), PIN, algorithm, time, challenge, digit, step);
      if (IMSSdk.enableDebugLog) {
         XLog.d("getOTPWithID " + var11);
      }

      return var11;
   }

   public boolean changePIN(@NonNull String userName, @NonNull String oldPIN, @NonNull String newPIN) {
      boolean var4 = this.infosecOTP.changePINNative(userName, oldPIN, newPIN);
      Set var5;
      if ((var5 = this.getSeedIDs(userName)) != null && var5.size() > 0) {
         Iterator var7 = var5.iterator();

         while(var7.hasNext()) {
            String var6 = (String)var7.next();
            this.infosecOTP.changePINNative(userName.concat("_").concat(var6), oldPIN, newPIN);
         }

         return var4;
      } else {
         return var4;
      }
   }

   public boolean changePINWithID(@NonNull String userName, @NonNull String seedID, @NonNull String oldPIN, @NonNull String newPIN) {
      return this.changePIN(userName, oldPIN, newPIN);
   }

   public boolean checkSeedExist(@NonNull String userName) {
      return this.infosecOTP.checkSeedNative(userName);
   }

   public boolean checkSeedExistWithID(@NonNull String userName, @NonNull String seedID) {
      return this.infosecOTP.checkSeedNative(userName.concat("_").concat(seedID));
   }

   public int verifyPIN(@NonNull String userName, @NonNull String PIN) {
      return this.infosecOTP.verifyPINNative(userName, PIN);
   }

   public int verifyPINWithID(@NonNull String userName, @NonNull String seedID, @NonNull String PIN) {
      return this.infosecOTP.verifyPINNative(userName.concat("_").concat(seedID), PIN);
   }

   public Set<String> getSeedIDs(@NonNull String userName) {
      return this.getUserSP(userName).getStringSet("SEED_IDS", (Set)null);
   }

   public boolean clearTokenData(@NonNull String userName) {
      boolean var2 = this.infosecOTP.clearData(userName);
      Set var3;
      if ((var3 = this.getSeedIDs(userName)) != null && var3.size() > 0) {
         Iterator var5 = var3.iterator();

         while(var5.hasNext()) {
            String var4 = (String)var5.next();
            this.infosecOTP.clearData(userName.concat("_").concat(var4));
         }

         return var2;
      } else {
         return var2;
      }
   }
}
